#!/bin/bash
#
# Shell script to check all the coding style check we have
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#  2 february 2014
# 27 february 2014
#  5 june     2014
#
# where you have store the scripts and the awk-files
BIN=./
DIR=./
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
nameOfTheScript=${0}
#
list=`ls ${WHERE}`
for eachFile in ${list}
do
  if [ -d ${eachFile} ] ;
  then
    # Is a directory
    if [ -r ${eachFile} ] ;
    then
      if [ -a ".no_coding_style" ] 
      then
        #echo "Datei .no_coding_file gefunden"
        exit
      fi
      if [ -a ".no_recursion" ] 
      then
        # do not explore the next directory(ies)
        touch .no_recursion
      else
        cd ${eachFile}
        ${nameOfTheScript} ${file_1}
        cd ..
      fi
    fi
  else
    if [ ! -e ${eachFile} ] ;
    then
      echo "no such file "${eachFile}
      exit
    fi
    # It is a file
    do_it="no"
    base_1=`basename ${eachFile} .h`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    base_1=`basename ${eachFile} .cpp`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    if [ ${do_it} == "yes" ] ;
    then
      ${BIN}/kernel.sh ${DIR}/Tabs-check.awk                ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Trim-check.awk                ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Twice.awk -v mode=check       ${eachFile}
      ${BIN}/kernel.sh ${DIR}/First.awk -v mode=check       ${eachFile}
      ${BIN}/kernel.sh ${DIR}/One-Line-If-check.awk         ${eachFile}
      ${BIN}/kernel.sh ${DIR}/One-Line-Else-check.awk       ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Pedantic-check.awk            ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Public.awk -v mode=check      ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Space-Include-check.awk       ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Enum-W.awk -v mode=check      ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Enum-Pedantic-check.awk       ${eachFile}
      ${BIN}/kernel.sh ${DIR}/NO-Space-check.awk            ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Default-1.awk -v mode=check   ${eachFile}
      ##${BIN}/kernel.sh ${DIR}/Default-2.awk -v mode=check ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Switch-W.awk -v mode=check    ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Comma-at-EOL.awk              ${eachFile}
      ${BIN}/kernel.sh ${DIR}/If-0-check.awk                ${eachFile}
      ${BIN}/kernel.sh ${DIR}/TypedefStruct-0-check.awk     ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Else-0-check.awk              ${eachFile}
      ${BIN}/kernel.sh ${DIR}/While-0-check.awk             ${eachFile}
      ${BIN}/kernel.sh ${DIR}/For-0-check.awk               ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Namespace-0-check.awk         ${eachFile}
      ${BIN}/kernel.sh ${DIR}/StarParenthesis-check.awk     ${eachFile}
      ${BIN}/kernel.sh ${DIR}/twoBrace.awk                  ${eachFile}
      #${BIN}/kernel.sh ${DIR}/SpaceUND.awk -v mode=check    ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Try-Catch-check.awk           ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Parenthesis-alone.awk          ${eachFile}
      ${BIN}/SpaceAfter.sh                                  ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Case-Brace.awk -v mode=check  ${eachFile}
    fi
  fi
done
