BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "mode is not correct";
      exit;
    }
  }
  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  # switchState may takes one of the next values
  S_normalLine        = 10;
  S_switchIsFound     = 11;
  S_caseIsFound       = 12;
  S_defaultIsFound    = 13;
  S_leftBraceIsFound  = 14;
  S_endOfBlockIsFound = 15;

  S_switchState = S_normalLine;

  testIt ="no";
  #testIt ="yes";
} # end of BEGIN

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function HowManyFirstSpace(inLine,   firstPLace)
{                                    # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  return firstPLace - 1;
}

function RIndex(inLine,whatChar,    i, lengthOfTheInLine, character, lastPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first "whatChar" character back from the end of the string "inLine"
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  lastPlace = 0;
  for (i = lengthOfTheInLine; i >= 1; i--) {
    character = substr(inLine, i, 1);
    if (character == whatChar) {
      lastPlace = i;
      break;
    }
  }
  return lastPlace;
}

function LookForPunkt(inLine,      lengthOfTheInLine, character, whereIsPunkt)
{                                # separate local variables from real  parameters  by  extra  spaces
  # look for leftBrace after case or default
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  character = substr(inLine, lengthOfTheInLine, 1);
  if (character == ":") {
    return lengthOfTheInLine;
  } else {
    if (testIt == "yes") {
      printf("look back to the :\n");
    }
    # look back to the :
    whereIsPunkt = RIndex(inLine, ":");
    if (whereIsPunkt > 0) {
      return whereIsPunkt;
    } else {
      return 0;
    }
  }
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(120)(%d)=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
        printf("whereIsComment_2= %d\n", whereIsComment_2);
        printf("whereIsString_1= %d\n", whereIsString_1);
        printf("whereIsString_2= %d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(151)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(156)partBeforeComment >>%s<<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(160)workLine >>%s<<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(166)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(176)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          lengthOfThePartBefore = length(partBeforeComment);
          letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          while (letter == " ") {
            tempBuffer = substr(partBeforeComment, 1, lengthOfThePartBefore- 1);
            partBeforeComment = tempBuffer;
            lengthOfThePartBefore = length(partBeforeComment);
            letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          }
          if (testIt == "yes") {
            printf("(190)partBeforeComment >>%s<<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(194)workLine >>%s<<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(229)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(234)partBeforeString >>%s<<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(238)workLine >>%s<<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(244)restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n", whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(254)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(259)partBeforeString >>%s<<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(263)workLine >>%s<<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(269)restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(279)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(286)restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(301)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(308)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(315)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(322)workLine >>%s<<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(327)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(331)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(339)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(345)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(377)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(382)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(389)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(396)workLine >>%s<<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(401)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(405)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(411)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(442)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(447)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(454)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(461)workLine >>%s<<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(466)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(470)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(476)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(484)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >>%s<<\n", workLine);
  }

  # look for Case... Brace
  theOutLine = FirstSpaceAway(workLine);
  if (testIt == "yes") {
    printf("switchState(505)(%d)=%d\n", NR, switchState);
  }
  switch(S_switchState) {
  case 10: # S_normalLine:
    # look for case [2]
    whereIsCase = index(theOutLine, "case ");
    if (whereIsCase == 1) {
      whereIsCaseDefault = index(workLine, "case ");
      if (mode == "check") {
        theOldLine = workLine;
      }
      if (testIt == "yes") {
        printf("switchState(517)(%d)=%d, changed to S_caseIsFound\n", NR);
      }
      S_switchState = S_caseIsFound;
    } else {
      # look for default [3]
      whereIsDefault = index(theOutLine, "default");
      if (whereIsDefault == 1) {
        whereIsCaseDefault = index(workLine, "default");
        if ( testIt == "yes") {
          printf("default found(526), NR=%d\n", NR);
        }
        if (mode == "check") {
          theOldLine = workLine;
        }
        if (testIt == "yes") {
          printf("switchState(532)(%d)=%d, changed to S_defaultIsFound\n", NR);
        }
        S_switchState = S_defaultIsFound;
      } else {
        if (mode == "change") {
          printf("%s\n", theLine);
        }
      }
    }
    switch(switchState) {
    case 12: # S_caseIsFound
    case 13: # S_defaultIsFound
      if (testIt == "yes") {
        printf("look for leftBrace after case or default at the same line\n");
      }
      # look for ": leftBrace" after case or default [7]
      whereIsPunkt = LookForPunkt(theOutLine);
      if (whereIsPunkt > 0) {
        if (testIt == "yes") {
          printf(": found(551) at %d, NR=%d\n", whereIsPunkt, NR);
        }
        lengthOfTheInLine = length(theOutLine);
        if (testIt == "yes") {
          printf("lengthOfTheInLine= %d\n", lengthOfTheInLine);
        }
        if (whereIsPunkt != lengthOfTheInLine) {
          # look for leftBrace [7] at the end of the line
          letter = substr(theOutLine, lengthOfTheInLine, 1);
          if (letter == leftBrace) {
            if (testIt == "yes") {
              printf("leftBrace found(562), NR=%d\n", NR);
            }
            if (testIt == "yes") {
              printf("switchState(565)(%d)=%d, changed to S_leftBraceIsFound\n", NR);
            }
            S_switchState = S_leftBraceIsFound;
            howManyFirst0 = HowManyFirstSpace(workLine);
            if (testIt == "yes") {
              printf("howManyFirst0(%d)=%d\n", NR, howManyFirst0);
            }
          } else {
            S_switchState = S_normalLine;
            if (testIt == "yes") {
              printf("NO leftBrace found(575), NR=%d\n", NR);
            }
          }
        } else {
          S_switchState = S_normalLine;
          if (testIt == "yes") {
            printf("NO leftBrace found(581), NR=%d\n", NR);
          }
        }
      } else {
        S_switchState = S_normalLine;
        if (testIt == "yes") {
          printf("NO leftBrace found(587), NR=%d\n", NR);
        }
      }
      if (mode == "change") {
        printf("%s\n", theLine);
      }
      break;
    }
    break;
  case 14: # S_leftBraceIsFound
    if (testIt == "yes") {
      printf("a new Block\n");
    }
    if (testIt == "yes") {
      printf("switchState(601)(%d)=%d\n", NR, switchState);
    }
    # look for rightBrace [11]
    whereIsRightBrace = index(theOutLine, rightBrace);
    if (whereIsRightBrace == 1) {
      whereIsRightBrace2 = index(workLine, rightBrace);
      if (testIt == "yes") {
        printf("rightBrace at %d, end of Block found(608), NR=%d\n", whereIsRightBrace, NR);
      }
      if (testIt == "yes") {
        printf("switchState(611)(%d)=%d, changed to S_normalLine\n", NR);
      }
      S_switchState = S_normalLine;
      if (mode == "change") {
        sub("    ", "", theLine);
        printf("%s\n", theLine);
      }
    } else {
      # other statment(s) [12]
      if (testIt == "yes") {
        printf("howManyFirst0(%d)=%d\n", NR, howManyFirst0);
      }
      howManyFirst1 = HowManyFirstSpace(workLine);
      if (testIt == "yes") {
        printf("howManyFirst1 - howManyFirst0(%d)=%d\n", NR, howManyFirst1 - howManyFirst0);
      }
      if (testIt == "yes") {
        printf("howManyFirst1(%d)=%d\n", NR, howManyFirst1);
      }
      if ((howManyFirst1 - howManyFirst0) > 4) {
        if (mode == "check") {
          printf("%d: Indentation=%d is too big: %s\n", NR, howManyFirst1- howManyFirst0, theLine);
          printf("%d: it should be: %d\n", NR, howManyFirst1- howManyFirst0 - 4);
        }
        if (mode == "change") {
          sub("    ", "", theLine);
        }
      } else {
        # OK
      }
      if (mode == "change") {
        printf("%s\n", theLine);
      }
    }
    break;
  } # switch(switchState)
}
