#!/bin/bash
#
# Shell script to INSTALL all the coding style utilities
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 15 march 2014
#
ID=`id -u`
if [ ${ID} -ne 0 ] ;
then
  echo "you must be root to run"
  exit
fi
#
# test if the needed binary are present
if [ ! -f /usr/bin/which ] ;
then
  echo "we need the binary which"
  exit
fi
LIST_OF_BINARIES="gawk "
for each_bin in ${LIST_OF_BINARIES}
do
  #echo "test the binary ${each_bin}"
  which ${each_bin} > /dev/null 2>&1
  how_status=${?}
  if [ ${how_status} != "0" ] ;
  then
    #echo "the status is "${how_status}
    echo "missing binary ${each_bin}"
    exit
  fi
done
# where to store the configuration info.
ETC_DIR="/etc/CodingStyle"
#
# where to store the CodingStyle utilities files
CODING_STYLE_DIR="/usr/local/CodingStyle"
#
# where to store the binary command files
CODING_STYLE_BIN="/usr/local/bin"
#
LIST_OF_COMMANDS="list_of_commands.txt"
LIST_OF_AWK_FILE="list_of_awk_file.txt"
#
# create the directory to store the configuration info.
mkdir -p ${ETC_DIR}
#
# create the directory to store the utilities files.
mkdir -p ${CODING_STYLE_DIR}
#
# create the configuration file.
echo "CODING_STYLE_DIR=${CODING_STYLE_DIR}"  > ${ETC_DIR}/CodingStyle.conf
echo "CODING_STYLE_BIN=${CODING_STYLE_BIN}" >> ${ETC_DIR}/CodingStyle.conf
echo "LIST_OF_COMMANDS=${LIST_OF_COMMANDS}" >> ${ETC_DIR}/CodingStyle.conf
echo "LIST_OF_AWK_FILE=${LIST_OF_AWK_FILE}" >> ${ETC_DIR}/CodingStyle.conf
#
# copy the list of commands and awk-files
cp list_of_commands.txt ${ETC_DIR}
cp list_of_awk_file.txt ${ETC_DIR}
#
# copy the commands
THE_COMMANDS=`cat ${ETC_DIR}/${LIST_OF_COMMANDS}`
for each_file in ${THE_COMMANDS}
do
  if [ -f ${CODING_STYLE_BIN}/${each_file} ] ;
  then
    echo "move command ${each_file}"
    mv ${CODING_STYLE_BIN}/${each_file} ${CODING_STYLE_BIN}/${each_file}.moved
  fi
  echo "modify command ${each_file}"
  gawk -f modify-command.awk \
      -v CODING_STYLE_DIR=${CODING_STYLE_DIR} \
      -v CODING_STYLE_BIN=${CODING_STYLE_BIN} \
      ${each_file} > ${each_file}.m
  echo "install command ${each_file}"
  cp ${each_file}.m ${CODING_STYLE_BIN}/${each_file} 
  chmod a+x ${CODING_STYLE_BIN}/${each_file}
done
#
# copy the awk-files
THE_AWK_FILES=`cat ${ETC_DIR}/${LIST_OF_AWK_FILE}`
for each_file in ${THE_AWK_FILES}
do
#  if [ -f ${CODING_STYLE_DIR}/${each_file} ] ;
#  then
#    echo "move awk-file ${each_file}"
#    mv ${CODING_STYLE_DIR}/${each_file} ${CODING_STYLE_DIR}/${each_file}.moved
#  fi
  echo "install awk-file ${each_file}"
  cp ${each_file} ${CODING_STYLE_DIR}/${each_file} 
done
