#!/bin/bash
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 12 january 2014
#  5 june    2014
#
# where you have store the script and the awk-program
BIN=./
DIR=./
#
liste_1="alignas decltype alignof noexcept typeid asm static_assert switch if catch while for sizeof new Q_FOREACH foreach FOREACH"
liste_2="do try enum union Q_FOREVER"
liste_3="try"
liste_4="bool char char16_t char32_t double float int long wchar_t signed unsigned short"
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
#
nameOfTheScript=${0}
#
list=`ls ${1}`
for eachFile in ${list}
do
  if [ -d ${eachFile} ] ;
  then
    # Is a directory
    if [ -r ${eachFile} ] ;
    then
      # is readable
      if [ ${eachFile} == ".git" ] ;
      then
        # no test on .git directory
        exit
      fi
      if [ -a ".no_coding_style" ] 
      then
        #echo "Datei .no_coding_file gefunden"
        exit
      fi
      if [ -a ".no_recursion" ] 
      then
        # do not explore the next directory(ies)
          touch .no_recursion
      else
        cd ${eachFile}
        ${nameOfTheScript} ${1}
        cd ..
      fi
    fi
  else
    if [ ! -f ${eachFile} ] ;
    then
      echo "no such file "${eachFile}
      exit
    fi
    # Is a file
    do_it="no"
    base_1=`basename ${eachFile} .h`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    base_1=`basename ${eachFile} .cpp`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    if [ ${do_it} == "yes" ] ;
    then
      for typ in ${liste_1}
      do
        ${BIN}/coding-style-check-SpaceAfterKeyword.sh ${typ} '(' ${eachFile}
      done
      for typ in ${liste_2}
      do
        ${BIN}/coding-style-check-SpaceAfterKeyword.sh ${typ} '{' ${eachFile}
      done
      for typ in ${liste_3}
      do
        ${BIN}/coding-style-check-SpaceAfterKeyword.sh ${typ} ':' ${eachFile}
      done
      for typ in ${liste_4}
      do
        ${BIN}/coding-style-check-SpaceAfterKeyword.sh ${typ} "star" ${eachFile}
      done
    fi
  fi
done
